quantileFun <- function(mY, pars1, pars2, resid1, resid2,
  probs=c(0.10, 0.25, 0.75, 0.90), n.ahead=3, n.sim=20000)
{
  ##forbered simulasjoner:
  mYhat <- matrix(NA, n.ahead+1, 3)
  iaar <- as.numeric(index(mY)[NROW(mY)])
  rownames(mYhat) <- paste0(c(iaar-1, iaar, iaar+1, iaar+2))
  colnames(mYhat) <- c("Y1hat", "X1t", "X2t")
  mYhat[1:2,] <- coredata(tail(mY, n=2))
  mSims <- matrix(NA, 3, n.sim)
  resid1 <- coredata(resid1)
  resid2 <- coredata(resid2)

  ##simulr:
  for(i in 1:n.sim){

    ##trekk n residual fra resid1:
    draw <- runif(1, min=0.5+1e-10, max=length(resid1)+0.5-1e-10)
    draw <- round(draw, digits=0)
    vResids <- resid1[ draw ]

    ##trekk to residualer fra resid2:
    draw <- runif(2, min=0.5+1e-10, max=length(resid2)+0.5-1e-10)
    draw <- round(draw, digits=0)
    vResids <- c(vResids, resid2[ draw ]) 

    ##t+1 prognose: blanda frekvens likning
    mYhat[2,"Y1hat"] <- pars1[1] +
      pars1[2]*as.numeric(mYhat[1,"Y1hat"]) +
      pars1[3]*as.numeric(mYhat[2,"X1t"]) +
      pars1[4]*as.numeric(mYhat[2,"X2t"]) + vResids[1]

    ##t+2 og t+3 prognoser: ar(1) likning
    for(j in 3:4){
      mYhat[j,"Y1hat"] <- pars2[1] +
        pars2[2]*as.numeric(mYhat[j-1,"Y1hat"]) + vResids[j-1]
    }

    ##record simulations:
    mSims[,i] <- as.numeric(mYhat[2:4,"Y1hat"])

  } #end for loop
  
  ##quantiles:
  result <- matrix(NA, n.ahead, length(probs))
  colnames(result) <- paste0(probs)
  rownames(result) <- paste0(c(iaar, iaar+1, iaar+2))
  for(i in 1:NROW(result)){
    result[i,] <- quantile(mSims[i,], probs=probs)
  }

  ##return result:
  return(result)
  
} #close function
